'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactButton = require('@fenderdigital/react-button');

var _reactButton2 = _interopRequireDefault(_reactButton);

var _reactSpinner = require('@fenderdigital/react-spinner');

var _reactSpinner2 = _interopRequireDefault(_reactSpinner);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LoadingSpinnerButton = function (_React$Component) {
  _inherits(LoadingSpinnerButton, _React$Component);

  function LoadingSpinnerButton() {
    _classCallCheck(this, LoadingSpinnerButton);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this));

    _this.state = { isButtonClicked: false };

    _this.handleClick = _this.handleClick.bind(_this);
    return _this;
  }

  LoadingSpinnerButton.prototype.componentDidUpdate = function componentDidUpdate(prevProps) {
    var loading = this.props.loading;

    if (prevProps.loading && !loading) {
      this.setButtonClicked(false);
    }
  };

  LoadingSpinnerButton.prototype.setButtonClicked = function setButtonClicked(isButtonClicked) {
    this.setState({ isButtonClicked: isButtonClicked });
  };

  LoadingSpinnerButton.prototype.handleClick = function handleClick(event) {
    var onClick = this.props.onClick;


    this.setButtonClicked(true);
    onClick(event);
  };

  LoadingSpinnerButton.prototype.render = function render() {
    var _props = this.props,
        children = _props.children,
        color = _props.color,
        dataId = _props.dataId,
        disabled = _props.disabled,
        fontStyles = _props.fontStyles,
        loading = _props.loading,
        requireClick = _props.requireClick,
        spinnerColor = _props.spinnerColor,
        spinnerWidth = _props.spinnerWidth,
        styles = _props.styles,
        type = _props.type;
    var isButtonClicked = this.state.isButtonClicked;


    var showSpinner = loading && (!requireClick || isButtonClicked);

    return _react2.default.createElement(
      _reactButton2.default,
      {
        dataId: dataId,
        fontStyles: fontStyles,
        styles: styles,
        color: color,
        disabled: disabled || showSpinner,
        onClick: this.handleClick,
        type: type
      },
      _react2.default.createElement(
        'div',
        { className: 'flex' },
        showSpinner && _react2.default.createElement(
          'div',
          { className: 'pr2' },
          _react2.default.createElement(_reactSpinner2.default, {
            bgColor: color,
            lineColor: spinnerColor,
            strokeBgColor: color,
            width: spinnerWidth,
            strokeWidth: 4
          })
        ),
        children
      )
    );
  };

  return LoadingSpinnerButton;
}(_react2.default.Component);

LoadingSpinnerButton.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.node.isRequired,
  loading: _propTypes2.default.bool.isRequired,
  disabled: _propTypes2.default.bool,
  fontStyles: _propTypes2.default.string,
  styles: _propTypes2.default.string,
  color: _propTypes2.default.string,
  spinnerColor: _propTypes2.default.string,
  dataId: _propTypes2.default.string,
  onClick: _propTypes2.default.func,
  spinnerWidth: _propTypes2.default.number,
  requireClick: _propTypes2.default.bool,
  type: _propTypes2.default.string
} : {};

LoadingSpinnerButton.defaultProps = {
  color: 'red',
  dataId: '',
  disabled: false,
  fontStyles: '',
  onClick: function onClick() {},
  requireClick: false,
  spinnerColor: 'white',
  spinnerWidth: 15,
  styles: '',
  type: 'button'
};

exports.default = LoadingSpinnerButton;
module.exports = exports['default'];